/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2210 from the
 * contents of Fast.xs. Do not edit this file, edit Fast.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

/* Autogenerated XS functions are static. */
#define XSUBPP_STATIC_XS

#line 1 "Fast.xs"
/*
  Copyright (C) 2007-2010 Tomash Brechko.  All rights reserved.

  This library is free software; you can redistribute it and/or modify
  it under the same terms as Perl itself, either Perl version 5.8.8
  or, at your option, any later version of Perl 5 you may have
  available.
*/

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "src/client.h"
#include <stdlib.h>
#include <string.h>


#define F_STORABLE  0x1
#define F_COMPRESS  0x2
#define F_UTF8      0x4


struct xs_state
{
  struct client *c;
  AV *servers;
  int compress_threshold;
  double compress_ratio;
  SV *compress_method;
  SV *decompress_method;
  SV *serialize_method;
  SV *deserialize_method;
  int utf8;
  size_t max_size;
};

typedef struct xs_state Cache_Memcached_Fast;


static
void
add_server(Cache_Memcached_Fast *memd, SV *addr_sv, double weight, int noreply)
{
  struct client *c = memd->c;
  static const int delim = ':';
  const char *host, *port;
  size_t host_len, port_len;
  STRLEN len;
  int res;

  av_push(memd->servers, newSVsv(addr_sv));

  if (weight <= 0.0)
    croak("Server weight should be positive");

  host = SvPV(addr_sv, len);
  /*
    NOTE: here we relay on the fact that host is zero-terminated.
  */
  port = strrchr(host, delim);
  if (port)
    {
      host_len = port - host;
      ++port;
      port_len = len - host_len - 1;
      res = client_add_server(c, host, host_len, port, port_len,
                              weight, noreply);
    }
  else
    {
      res = client_add_server(c, host, len, NULL, 0, weight, noreply);
    }
  if (res != MEMCACHED_SUCCESS)
    croak("Not enough memory");
}


static
void
parse_server(Cache_Memcached_Fast *memd, SV *sv)
{
  if (! SvROK(sv))
    {
      add_server(memd, sv, 1.0, 0);
    }
  else
    {
      switch (SvTYPE(SvRV(sv)))
        {
        case SVt_PVHV:
          {
            HV *hv = (HV *) SvRV(sv);
            SV **addr_sv, **ps;
            double weight = 1.0;
            int noreply = 0;

            addr_sv = hv_fetch(hv, "address", 7, 0);
            if (addr_sv)
              SvGETMAGIC(*addr_sv);
            else
              croak("server should have { address => $addr }");
            ps = hv_fetch(hv, "weight", 6, 0);
            if (ps)
              SvGETMAGIC(*ps);
            if (ps && SvOK(*ps))
              weight = SvNV(*ps);
            ps = hv_fetch(hv, "noreply", 7, 0);
            if (ps)
              SvGETMAGIC(*ps);
            if (ps && SvOK(*ps))
              noreply = SvTRUE(*ps);
            add_server(memd, *addr_sv, weight, noreply);
          }
          break;

        case SVt_PVAV:
          {
            AV *av = (AV *) SvRV(sv);
            SV **addr_sv, **weight_sv;
            double weight = 1.0;

            addr_sv = av_fetch(av, 0, 0);
            if (addr_sv)
              SvGETMAGIC(*addr_sv);
            else
              croak("server should be [$addr, $weight]");
            weight_sv = av_fetch(av, 1, 0);
            if (weight_sv)
              weight = SvNV(*weight_sv);
            add_server(memd, *addr_sv, weight, 0);
          }
          break;

        default:
          croak("Not a hash or array reference");
          break;
        }
    }
}


static
void
parse_serialize(Cache_Memcached_Fast *memd, HV *conf)
{
  SV **ps;

  memd->utf8 = 0;
  memd->serialize_method = NULL;
  memd->deserialize_method = NULL;

  ps = hv_fetch(conf, "utf8", 4, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    memd->utf8 = SvTRUE(*ps);

  ps = hv_fetch(conf, "serialize_methods", 17, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    {
      AV *av = (AV *) SvRV(*ps);
      memd->serialize_method = newSVsv(*av_fetch(av, 0, 0));
      memd->deserialize_method = newSVsv(*av_fetch(av, 1, 0));
    }

  if (! memd->serialize_method)
    croak("Serialize method is not specified");

  if (! memd->deserialize_method)
    croak("Deserialize method is not specified");
}


static
void
parse_compress(Cache_Memcached_Fast *memd, HV *conf)
{
  SV **ps;

  memd->compress_threshold = -1;
  memd->compress_ratio = 0.8;
  memd->compress_method = NULL;
  memd->decompress_method = NULL;

  ps = hv_fetch(conf, "compress_threshold", 18, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    memd->compress_threshold = SvIV(*ps);

  ps = hv_fetch(conf, "compress_ratio", 14, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    memd->compress_ratio = SvNV(*ps);

  ps = hv_fetch(conf, "compress_methods", 16, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    {
      AV *av = (AV *) SvRV(*ps);
      memd->compress_method = newSVsv(*av_fetch(av, 0, 0));
      memd->decompress_method = newSVsv(*av_fetch(av, 1, 0));
    }
  else if (memd->compress_threshold > 0)
    {
      warn("Compression module was not found, disabling compression");
      memd->compress_threshold = -1;
    }
}


static
void
parse_config(Cache_Memcached_Fast *memd, HV *conf)
{
  struct client *c = memd->c;
  SV **ps;

  memd->servers = newAV();

  ps = hv_fetch(conf, "ketama_points", 13, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    {
      int res = client_set_ketama_points(c, SvIV(*ps));
      if (res != MEMCACHED_SUCCESS)
        croak("client_set_ketama() failed");
    }

  ps = hv_fetch(conf, "hash_namespace", 14, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_hash_namespace(c, SvTRUE(*ps));

  ps = hv_fetch(conf, "servers", 7, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    {
      AV *a;
      int max_index, i;

      if (! SvROK(*ps) || SvTYPE(SvRV(*ps)) != SVt_PVAV)
        croak("Not an array reference");
      a = (AV *) SvRV(*ps);
      max_index = av_len(a);
      for (i = 0; i <= max_index; ++i)
        {
          ps = av_fetch(a, i, 0);
          if (! ps)
            continue;

          SvGETMAGIC(*ps);
          parse_server(memd, *ps);
        }
    }

  ps = hv_fetch(conf, "namespace", 9, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    {
      const char *ns;
      STRLEN len;
      ns = SvPV(*ps, len);
      if (client_set_prefix(c, ns, len) != MEMCACHED_SUCCESS)
        croak("Not enough memory");
    }

  ps = hv_fetch(conf, "connect_timeout", 15, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_connect_timeout(c, SvNV(*ps) * 1000.0);

  ps = hv_fetch(conf, "io_timeout", 10, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_io_timeout(c, SvNV(*ps) * 1000.0);

  /* For compatibility with Cache::Memcached.  */
  ps = hv_fetch(conf, "select_timeout", 14, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_io_timeout(c, SvNV(*ps) * 1000.0);

  ps = hv_fetch(conf, "max_failures", 12, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_max_failures(c, SvIV(*ps));

  ps = hv_fetch(conf, "failure_timeout", 15, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_failure_timeout(c, SvIV(*ps));

  ps = hv_fetch(conf, "close_on_error", 14, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_close_on_error(c, SvTRUE(*ps));

  ps = hv_fetch(conf, "nowait", 6, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_nowait(c, SvTRUE(*ps));

  ps = hv_fetch(conf, "max_size", 8, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    memd->max_size = SvUV(*ps);
  else
    memd->max_size = 1024 * 1024;

  parse_compress(memd, conf);
  parse_serialize(memd, conf);
}


static inline
SV *
compress(Cache_Memcached_Fast *memd, SV *sv, flags_type *flags)
{
  if (memd->compress_threshold > 0)
    {
      STRLEN len = sv_len(sv);
      SV *csv, *bsv;
      int count;
      dSP;

      if (len < (STRLEN) memd->compress_threshold)
        return sv;

      csv = newSV(0);

      PUSHMARK(SP);
      XPUSHs(sv_2mortal(newRV_inc(sv)));
      XPUSHs(sv_2mortal(newRV_noinc(csv)));
      PUTBACK;

      count = call_sv(memd->compress_method, G_SCALAR);

      SPAGAIN;

      if (count != 1)
        croak("Compress method returned nothing");

      bsv = POPs;
      if (SvTRUE(bsv) && sv_len(csv) <= len * memd->compress_ratio)
        {
          sv = csv;
          *flags |= F_COMPRESS;
        }

      PUTBACK;
    }

  return sv;
}


static inline
int
decompress(Cache_Memcached_Fast *memd, SV **sv, flags_type flags)
{
  int res = 1;

  if (flags & F_COMPRESS)
    {
      SV *rsv, *bsv;
      int count;
      dSP;

      rsv = newSV(0);

      PUSHMARK(SP);
      XPUSHs(sv_2mortal(newRV_inc(*sv)));
      XPUSHs(sv_2mortal(newRV_inc(rsv)));
      PUTBACK;

      count = call_sv(memd->decompress_method, G_SCALAR);

      SPAGAIN;

      if (count != 1)
        croak("Decompress method returned nothing");

      bsv = POPs;
      if (SvTRUE(bsv))
        {
          SvREFCNT_dec(*sv);
          *sv = rsv;
        }
      else
        {
          SvREFCNT_dec(rsv);
          res = 0;
        }

      PUTBACK;
    }

  return res;
}


static inline
SV *
serialize(Cache_Memcached_Fast *memd, SV *sv, flags_type *flags)
{
  if (SvROK(sv))
    {
      int count;
      dSP;

      PUSHMARK(SP);
      XPUSHs(sv);
      PUTBACK;

      count = call_sv(memd->serialize_method, G_SCALAR);

      SPAGAIN;

      if (count != 1)
        croak("Serialize method returned nothing");

      sv = POPs;
      *flags |= F_STORABLE;

      PUTBACK;
    }
  else if (memd->utf8 && SvUTF8(sv))
    {
      /* Copy the value because we will modify it in place.  */
      sv = sv_2mortal(newSVsv(sv));
      sv_utf8_encode(sv);
      *flags |= F_UTF8;
    }

  return sv;
}


static inline
int
deserialize(Cache_Memcached_Fast *memd, SV **sv, flags_type flags)
{
  int res = 1;

  if (flags & F_STORABLE)
    {
      SV *rsv;
      int count;
      dSP;

      PUSHMARK(SP);
      XPUSHs(*sv);
      PUTBACK;

      /* FIXME: do we need G_KEPEERR here?  */
      count = call_sv(memd->deserialize_method, G_SCALAR | G_EVAL);

      SPAGAIN;

      if (count != 1)
        croak("Deserialize method returned nothing");

      rsv = POPs;
      if (! SvTRUE(ERRSV))
        {
          SvREFCNT_dec(*sv);
          *sv = SvREFCNT_inc(rsv);
        }
      else
        {
          res = 0;
        }

      PUTBACK;
    }
  else if ((flags & F_UTF8) && memd->utf8)
    {
      res = sv_utf8_decode(*sv);
    }
   
  return res;
}


static
void *
alloc_value(value_size_type value_size, void **opaque)
{
  SV *sv;
  char *res;

  sv = newSVpvn("", 0);
  res = SvGROW(sv, value_size + 1); /* FIXME: check OOM.  */
  res[value_size] = '\0';
  SvCUR_set(sv, value_size);

  *opaque = sv;

  return (void *) res;
}


static
void
free_value(void *opaque)
{
  SV *sv = (SV *) opaque;

  SvREFCNT_dec(sv);
}


struct xs_value_result
{
  Cache_Memcached_Fast *memd;  
  SV *vals;
};


static
void
svalue_store(void *arg, void *opaque, int key_index, void *meta)
{
  SV *value_sv = (SV *) opaque;
  struct xs_value_result *value_res = (struct xs_value_result *) arg;
  struct meta_object *m = (struct meta_object *) meta;

  /* Suppress warning about unused key_index.  */
  if (key_index) {}

  if (! decompress(value_res->memd, &value_sv, m->flags)
      || ! deserialize(value_res->memd, &value_sv, m->flags))
    {
      free_value(value_sv);
      return;
    }

  if (! m->use_cas)
    {
      value_res->vals = value_sv;
    }
  else
    {
      AV *cas_val = newAV();
      av_extend(cas_val, 1);
      av_push(cas_val, newSVuv(m->cas));
      av_push(cas_val, value_sv);
      value_res->vals = newRV_noinc((SV *) cas_val);
    }
}


static
void
mvalue_store(void *arg, void *opaque, int key_index, void *meta)
{
  SV *value_sv = (SV *) opaque;
  struct xs_value_result *value_res = (struct xs_value_result *) arg;
  struct meta_object *m = (struct meta_object *) meta;

  if (! decompress(value_res->memd, &value_sv, m->flags)
      || ! deserialize(value_res->memd, &value_sv, m->flags))
    {
      free_value(value_sv);
      return;
    }

  if (! m->use_cas)
    {
      av_store((AV *) value_res->vals, key_index, value_sv);
    }
  else
    {
      AV *cas_val = newAV();
      av_extend(cas_val, 1);
      av_push(cas_val, newSVuv(m->cas));
      av_push(cas_val, value_sv);
      av_store((AV *) value_res->vals, key_index, newRV_noinc((SV *) cas_val));
    }
}


static
void
result_store(void *arg, void *opaque, int key_index, void *meta)
{
  AV *av = (AV *) arg;
  int res = (long) opaque;

  /* Suppress warning about unused meta.  */
  if (meta) {}

  if (res)
    av_store(av, key_index, newSViv(res));
  else
    av_store(av, key_index, newSVpvn("", 0));
}


static
void
embedded_store(void *arg, void *opaque, int key_index, void *meta)
{
  AV *av = (AV *) arg;
  SV *sv = (SV *) opaque;

  /* Suppress warning about unused meta.  */
  if (meta) {}

  av_store(av, key_index, sv);
}


#line 647 "Fast.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 699 "Fast.c"
static
XS(XS_Cache__Memcached__Fast__new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "class, conf");
    {
	char *	class = (char *)SvPV_nolen(ST(0));
	SV *	conf = ST(1);
#line 643 "Fast.xs"
        Cache_Memcached_Fast *memd;
#line 715 "Fast.c"
	Cache_Memcached_Fast *	RETVAL;
#line 645 "Fast.xs"
        memd = (Cache_Memcached_Fast *) malloc(sizeof(Cache_Memcached_Fast));
        memd->c = client_init();
        if (! memd->c)
          croak("Not enough memory");
        if (! SvROK(conf) || SvTYPE(SvRV(conf)) != SVt_PVHV)
          croak("Not a hash reference");
        parse_config(memd, (HV *) SvRV(conf));
        RETVAL = memd;
#line 726 "Fast.c"
	ST(0) = sv_newmortal();
        sv_setref_pv(ST(0), class, (void*) RETVAL);
    }
    XSRETURN(1);
}

static
XS(XS_Cache__Memcached__Fast__destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "memd");
    {
	Cache_Memcached_Fast *	memd;

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 662 "Fast.xs"
        client_destroy(memd->c);
        if (memd->compress_method)
          {
            SvREFCNT_dec(memd->compress_method);
            SvREFCNT_dec(memd->decompress_method);
          }
        if (memd->serialize_method)
          {
            SvREFCNT_dec(memd->serialize_method);
            SvREFCNT_dec(memd->deserialize_method);
          }
        SvREFCNT_dec(memd->servers);
        free(memd);
#line 771 "Fast.c"
    }
    XSRETURN_EMPTY;
}

static
XS(XS_Cache__Memcached__Fast_enable_compress)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "memd, enable");
    {
	Cache_Memcached_Fast *	memd;
	bool	enable = (bool)SvTRUE(ST(1));

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 683 "Fast.xs"
        if (enable && ! memd->compress_method)
          warn("Compression module was not found, can't enable compression");
        else if ((memd->compress_threshold > 0) != enable)
          memd->compress_threshold = -memd->compress_threshold;
#line 806 "Fast.c"
    }
    XSRETURN_EMPTY;
}

static
XS(XS_Cache__Memcached__Fast_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 700 "Fast.xs"
        int noreply;
        struct result_object object =
            { NULL, result_store, NULL, NULL };
        const char *key;
        STRLEN key_len;
        cas_type cas = 0;
        const void *buf;
        STRLEN buf_len;
        flags_type flags = 0;
        exptime_type exptime = 0;
        int arg = 1;
        SV *sv;
#line 839 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 713 "Fast.xs"
        object.arg = newAV();
        sv_2mortal((SV *) object.arg);
        noreply = (GIMME_V == G_VOID);
        client_reset(memd->c, &object, noreply);
        key = SvPV(ST(arg), key_len);
        ++arg;
        if (ix == CMD_CAS)
          {
            cas = SvUV(ST(arg));
            ++arg;
          }
        sv = ST(arg);
        ++arg;
        sv = serialize(memd, sv, &flags);
        sv = compress(memd, sv, &flags);
        buf = (void *) SvPV(sv, buf_len);
        if (buf_len > memd->max_size)
          XSRETURN_EMPTY;
        if (items > arg)
          {
            /* exptime doesn't have to be defined.  */
            sv = ST(arg);
            SvGETMAGIC(sv);
            if (SvOK(sv))
              exptime = SvIV(sv);
          }
        if (ix != CMD_CAS)
          {
            client_prepare_set(memd->c, ix, 0, key, key_len, flags,
                               exptime, buf, buf_len);
          }
        else
          {
            client_prepare_cas(memd->c, 0, key, key_len, cas, flags,
                               exptime, buf, buf_len);
          }
        client_execute(memd->c);
        if (! noreply)
          {
            SV **val = av_fetch(object.arg, 0, 0);
            if (val)
              {
                PUSHs(*val);
                XSRETURN(1);
              }
          }
#line 899 "Fast.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_Cache__Memcached__Fast_set_multi)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 772 "Fast.xs"
        int i, noreply;
        struct result_object object =
            { NULL, result_store, NULL, NULL };
#line 924 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 776 "Fast.xs"
        object.arg = newAV();
        sv_2mortal((SV *) object.arg);
        noreply = (GIMME_V == G_VOID);
        client_reset(memd->c, &object, noreply);
        for (i = 1; i < items; ++i)
          {
            SV *sv;
            AV *av;
            const char *key;
            STRLEN key_len;
            /*
              gcc-3.4.2 gives a warning about possibly uninitialized
              cas, so we set it to zero.
            */
            cas_type cas = 0;
            const void *buf;
            STRLEN buf_len;
            flags_type flags = 0;
            exptime_type exptime = 0;
            int arg = 0;

            sv = ST(i);
            if (! (SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVAV))
              croak("Not an array reference");

            av = (AV *) SvRV(sv);
            /*
              The following values should be defined, so we do not do
              any additional checks for speed.
            */
            key = SvPV(*av_fetch(av, arg, 0), key_len);
            ++arg;
            if (ix == CMD_CAS)
              {
                cas = SvUV(*av_fetch(av, arg, 0));
                ++arg;
              }
            sv = *av_fetch(av, arg, 0);
            ++arg;
            sv = serialize(memd, sv, &flags);
            sv = compress(memd, sv, &flags);
            buf = (void *) SvPV(sv, buf_len);
            if (buf_len > memd->max_size)
              continue;
            if (av_len(av) >= arg)
              {
                /* exptime doesn't have to be defined.  */
                SV **ps = av_fetch(av, arg, 0);
                if (ps)
                  SvGETMAGIC(*ps);
                if (ps && SvOK(*ps))
                  exptime = SvIV(*ps);
              }

            if (ix != CMD_CAS)
              {
                client_prepare_set(memd->c, ix, i - 1, key, key_len, flags,
                                   exptime, buf, buf_len);
              }
            else
              {
                client_prepare_cas(memd->c, i - 1, key, key_len, cas, flags,
                                   exptime, buf, buf_len);
              }
          }
        client_execute(memd->c);
        if (! noreply)
          {
            if (GIMME_V == G_SCALAR)
              {
                HV *hv = newHV();
                for (i = 0; i <= av_len(object.arg); ++i)
                  {
                    SV **val = av_fetch(object.arg, i, 0);
                    if (val && SvOK(*val))
                      {
                        SV *key = *av_fetch((AV *) SvRV(ST(i + 1)), 0, 0);
                        HE *he = hv_store_ent(hv, key,
                                              SvREFCNT_inc(*val), 0);
                        if (! he)
                          SvREFCNT_dec(*val);
                      }
                  }
                PUSHs(sv_2mortal(newRV_noinc((SV *) hv)));
                XSRETURN(1);
              }
            else
              {
                I32 max_index = av_len(object.arg);
                EXTEND(SP, max_index + 1);
                for (i = 0; i <= max_index; ++i)
                  {
                    SV **val = av_fetch(object.arg, i, 0);
                    if (val)
                      PUSHs(*val);
                    else
                      PUSHs(&PL_sv_undef);
                  }
                XSRETURN(max_index + 1);
              }
          }
#line 1039 "Fast.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_Cache__Memcached__Fast_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 886 "Fast.xs"
        struct xs_value_result value_res;
        struct result_object object =
            { alloc_value, svalue_store, free_value, &value_res };
        const char *key;
        STRLEN key_len;
#line 1066 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 892 "Fast.xs"
        value_res.memd = memd;
        value_res.vals = NULL;
        client_reset(memd->c, &object, 0);
        key = SvPV(ST(1), key_len);
        client_prepare_get(memd->c, ix, 0, key, key_len);
        client_execute(memd->c);
        if (value_res.vals)
          {
            PUSHs(sv_2mortal(value_res.vals));
            XSRETURN(1);
          }
#line 1091 "Fast.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_Cache__Memcached__Fast_get_multi)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 912 "Fast.xs"
        struct xs_value_result value_res;
        struct result_object object =
            { alloc_value, mvalue_store, free_value, &value_res };
        int i, key_count;
        HV *hv;
#line 1118 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 918 "Fast.xs"
        key_count = items - 1;
        value_res.memd = memd;
        value_res.vals = (SV *) newAV();
        sv_2mortal(value_res.vals);
        av_extend((AV *) value_res.vals, key_count - 1);
        client_reset(memd->c, &object, 0);
        for (i = 0; i < key_count; ++i)
          {
            const char *key;
            STRLEN key_len;

            key = SvPV(ST(i + 1), key_len);
            client_prepare_get(memd->c, ix, i, key, key_len);
          }
        client_execute(memd->c);
        hv = newHV();
        for (i = 0; i <= av_len((AV *) value_res.vals); ++i)
          {
            SV **val = av_fetch((AV *) value_res.vals, i, 0);
            if (val && SvOK(*val))
              {
                SV *key = ST(i + 1);
                HE *he = hv_store_ent(hv, key,
                                      SvREFCNT_inc(*val), 0);
                if (! he)
                  SvREFCNT_dec(*val);
              }
          }
        PUSHs(sv_2mortal(newRV_noinc((SV *) hv)));
        XSRETURN(1);
#line 1162 "Fast.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_Cache__Memcached__Fast_incr)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 957 "Fast.xs"
        struct result_object object =
            { alloc_value, embedded_store, NULL, NULL };
        int noreply;
        const char *key;
        STRLEN key_len;
        arith_type arg = 1;
#line 1190 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 964 "Fast.xs"
        object.arg = newAV();
        sv_2mortal((SV *) object.arg);
        noreply = (GIMME_V == G_VOID);
        client_reset(memd->c, &object, noreply);
        key = SvPV(ST(1), key_len);
        if (items > 2)
          {
            /* increment doesn't have to be defined.  */
            SV *sv = ST(2);
            SvGETMAGIC(sv);
            if (SvOK(sv))
              arg = SvUV(sv);
          }
        client_prepare_incr(memd->c, ix, 0, key, key_len, arg);
        client_execute(memd->c);
        if (! noreply)
          {
            SV **val = av_fetch(object.arg, 0, 0);
            if (val)
              {
                PUSHs(*val);
                XSRETURN(1);
              }
          }
#line 1228 "Fast.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_Cache__Memcached__Fast_incr_multi)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 997 "Fast.xs"
        struct result_object object =
            { alloc_value, embedded_store, NULL, NULL };
        int i, noreply;
#line 1253 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 1001 "Fast.xs"
        object.arg = newAV();
        sv_2mortal((SV *) object.arg);
        noreply = (GIMME_V == G_VOID);
        client_reset(memd->c, &object, noreply);
        for (i = 1; i < items; ++i)
          {
            SV *sv;
            AV *av;
            const char *key;
            STRLEN key_len;
            arith_type arg = 1;

            sv = ST(i);
            if (! SvROK(sv))
              {
                key = SvPV(sv, key_len);
              }
            else
              {
                if (SvTYPE(SvRV(sv)) != SVt_PVAV)
                  croak("Not an array reference");

                av = (AV *) SvRV(sv);
                /*
                  The following values should be defined, so we do not
                  do any additional checks for speed.
                */
                key = SvPV(*av_fetch(av, 0, 0), key_len);
                if (av_len(av) >= 1)
                  {
                    /* increment doesn't have to be defined.  */
                    SV **ps = av_fetch(av, 1, 0);
                    if (ps)
                      SvGETMAGIC(*ps);
                    if (ps && SvOK(*ps))
                      arg = SvUV(*ps);
                  }
              }

            client_prepare_incr(memd->c, ix, i - 1, key, key_len, arg);
          }
        client_execute(memd->c);
        if (! noreply)
          {
            if (GIMME_V == G_SCALAR)
              {
                HV *hv = newHV();
                for (i = 0; i <= av_len(object.arg); ++i)
                  {
                    SV **val = av_fetch(object.arg, i, 0);
                    if (val && SvOK(*val))
                      {
                        SV *key;
                        HE *he;

                        key = ST(i + 1);
                        if (SvROK(key))
                          key = *av_fetch((AV *) SvRV(key), 0, 0);

                        he = hv_store_ent(hv, key, SvREFCNT_inc(*val), 0);
                        if (! he)
                          SvREFCNT_dec(*val);
                      }
                  }
                PUSHs(sv_2mortal(newRV_noinc((SV *) hv)));
                XSRETURN(1);
              }
            else
              {
                I32 max_index = av_len(object.arg);
                EXTEND(SP, max_index + 1);
                for (i = 0; i <= max_index; ++i)
                  {
                    SV **val = av_fetch(object.arg, i, 0);
                    if (val)
                      PUSHs(*val);
                    else
                      PUSHs(&PL_sv_undef);
                  }
                XSRETURN(max_index + 1);
              }
          }
#line 1349 "Fast.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_Cache__Memcached__Fast_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 1090 "Fast.xs"
        struct result_object object =
            { NULL, result_store, NULL, NULL };
        int noreply;
        const char *key;
        STRLEN key_len;
#line 1375 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 1096 "Fast.xs"
        object.arg = newAV();
        sv_2mortal((SV *) object.arg);
        noreply = (GIMME_V == G_VOID);
        client_reset(memd->c, &object, noreply);
        key = SvPV(ST(1), key_len);
        if (items > 2)
          {
            /* Compatibility with old (key, delay) syntax.  */

            /* delay doesn't have to be defined.  */
            SV *sv = ST(2);
            SvGETMAGIC(sv);
            if (SvOK(sv) && SvUV(sv) != 0)
              warn("non-zero delete expiration time is ignored");
          }
        client_prepare_delete(memd->c, 0, key, key_len);
        client_execute(memd->c);
        if (! noreply)
          {
            SV **val = av_fetch(object.arg, 0, 0);
            if (val)
              {
                PUSHs(*val);
                XSRETURN(1);
              }
          }
#line 1415 "Fast.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_Cache__Memcached__Fast_delete_multi)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 1129 "Fast.xs"
        struct result_object object =
            { NULL, result_store, NULL, NULL };
        int i, noreply;
#line 1439 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 1133 "Fast.xs"
        object.arg = newAV();
        sv_2mortal((SV *) object.arg);
        noreply = (GIMME_V == G_VOID);
        client_reset(memd->c, &object, noreply);
        for (i = 1; i < items; ++i)
          {
            SV *sv;
            const char *key;
            STRLEN key_len;

            sv = ST(i);
            if (! SvROK(sv))
              {
                key = SvPV(sv, key_len);
              }
            else
              {
                /* Compatibility with old [key, delay] syntax.  */

                AV *av;

                if (SvTYPE(SvRV(sv)) != SVt_PVAV)
                  croak("Not an array reference");

                av = (AV *) SvRV(sv);
                /*
                  The following values should be defined, so we do not
                  do any additional checks for speed.
                */
                key = SvPV(*av_fetch(av, 0, 0), key_len);
                if (av_len(av) >= 1)
                  {
                    /* delay doesn't have to be defined.  */
                    SV **ps = av_fetch(av, 1, 0);
                    if (ps)
                      SvGETMAGIC(*ps);
                    if (ps && SvOK(*ps) && SvUV(*ps) != 0)
                      warn("non-zero delete expiration time is ignored");
                  }
              }

            client_prepare_delete(memd->c, i - 1, key, key_len);
          }
        client_execute(memd->c);
        if (! noreply)
          {
            if (GIMME_V == G_SCALAR)
              {
                HV *hv = newHV();
                for (i = 0; i <= av_len(object.arg); ++i)
                  {
                    SV **val = av_fetch(object.arg, i, 0);
                    if (val && SvOK(*val))
                      {
                        SV *key;
                        HE *he;

                        key = ST(i + 1);
                        if (SvROK(key))
                          key = *av_fetch((AV *) SvRV(key), 0, 0);

                        he = hv_store_ent(hv, key, SvREFCNT_inc(*val), 0);
                        if (! he)
                          SvREFCNT_dec(*val);
                      }
                  }
                PUSHs(sv_2mortal(newRV_noinc((SV *) hv)));
                XSRETURN(1);
              }
            else
              {
                I32 max_index = av_len(object.arg);
                EXTEND(SP, max_index + 1);
                for (i = 0; i <= max_index; ++i)
                  {
                    SV **val = av_fetch(object.arg, i, 0);
                    if (val)
                      PUSHs(*val);
                    else
                      PUSHs(&PL_sv_undef);
                  }
                XSRETURN(max_index + 1);
              }
          }
#line 1537 "Fast.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_Cache__Memcached__Fast_flush_all)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    {
	Cache_Memcached_Fast *	memd;
#line 1224 "Fast.xs"
        delay_type delay = 0;
        struct result_object object =
            { NULL, result_store, NULL, NULL };
        int noreply;
#line 1560 "Fast.c"
	HV *	RETVAL;

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 1229 "Fast.xs"
        RETVAL = newHV();
        /* Why sv_2mortal() is needed is explained in perlxs.  */
        sv_2mortal((SV *) RETVAL);
        object.arg = sv_2mortal((SV *) newAV());
        if (items > 1)
          {
            SV *sv = ST(1);
            SvGETMAGIC(sv);
            if (SvOK(sv))
              delay = SvUV(sv);
          }
        noreply = (GIMME_V == G_VOID);
        client_flush_all(memd->c, delay, &object, noreply);
        if (! noreply)
          {
            int i;
            for (i = 0; i <= av_len(object.arg); ++i)
              {
                SV **server = av_fetch(memd->servers, i, 0);
                SV **version = av_fetch(object.arg, i, 0);
                if (version && SvOK(*version))
                  {
                    HE *he = hv_store_ent(RETVAL, *server,
                                          SvREFCNT_inc(*version), 0);
                    if (! he)
                      SvREFCNT_dec(*version);
                  }
              }
          }
#line 1604 "Fast.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

static
XS(XS_Cache__Memcached__Fast_nowait_push)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "memd");
    {
	Cache_Memcached_Fast *	memd;

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 1267 "Fast.xs"
        client_nowait_push(memd->c);
#line 1637 "Fast.c"
    }
    XSRETURN_EMPTY;
}

static
XS(XS_Cache__Memcached__Fast_server_versions)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "memd");
    {
	Cache_Memcached_Fast *	memd;
#line 1275 "Fast.xs"
        struct result_object object =
            { alloc_value, embedded_store, NULL, NULL };
        int i;
#line 1658 "Fast.c"
	HV *	RETVAL;

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 1279 "Fast.xs"
        RETVAL = newHV();
        /* Why sv_2mortal() is needed is explained in perlxs.  */
        sv_2mortal((SV *) RETVAL);
        object.arg = sv_2mortal((SV *) newAV());
        client_server_versions(memd->c, &object);
        for (i = 0; i <= av_len(object.arg); ++i)
          {
            SV **server = av_fetch(memd->servers, i, 0);
            SV **version = av_fetch(object.arg, i, 0);
            if (version && SvOK(*version))
              {
                HE *he = hv_store_ent(RETVAL, *server,
                                      SvREFCNT_inc(*version), 0);
                if (! he)
                  SvREFCNT_dec(*version);
              }
          }
#line 1690 "Fast.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

static
XS(XS_Cache__Memcached__Fast_namespace)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    {
	Cache_Memcached_Fast *	memd;
#line 1305 "Fast.xs"
        const char *ns;
        size_t len;
#line 1712 "Fast.c"
	SV *	RETVAL;

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 1308 "Fast.xs"
        ns = client_get_prefix(memd->c, &len);
        RETVAL = newSVpv(ns, len);
        if (items > 1)
          {
            ns = SvPV(ST(1), len);
            if (client_set_prefix(memd->c, ns, len) != MEMCACHED_SUCCESS)
              croak("Not enough memory");
          }
#line 1735 "Fast.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

static
XS(XS_Cache__Memcached__Fast_disconnect_all)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "memd");
    {
	Cache_Memcached_Fast *	memd;

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast");
#line 1325 "Fast.xs"
        client_reinit(memd->c);
#line 1768 "Fast.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
#if (__GNUC__ >= 4) && defined(__ELF__)
XS(boot_Cache__Memcached__Fast) __attribute__((visibility("default")));
#else
XS(boot_Cache__Memcached__Fast); /* prototype to pass -Wmissing-prototypes */
#endif
XS(boot_Cache__Memcached__Fast)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        (void)newXSproto_portable("Cache::Memcached::Fast::_new", XS_Cache__Memcached__Fast__new, file, "$$");
        (void)newXSproto_portable("Cache::Memcached::Fast::_destroy", XS_Cache__Memcached__Fast__destroy, file, "$");
        (void)newXSproto_portable("Cache::Memcached::Fast::enable_compress", XS_Cache__Memcached__Fast_enable_compress, file, "$$");
        cv = newXSproto_portable("Cache::Memcached::Fast::set", XS_Cache__Memcached__Fast_set, file, "$@");
        XSANY.any_i32 = 0 ;
        cv = newXSproto_portable("Cache::Memcached::Fast::cas", XS_Cache__Memcached__Fast_set, file, "$@");
        XSANY.any_i32 = CMD_CAS ;
        cv = newXSproto_portable("Cache::Memcached::Fast::append", XS_Cache__Memcached__Fast_set, file, "$@");
        XSANY.any_i32 = CMD_APPEND ;
        cv = newXSproto_portable("Cache::Memcached::Fast::replace", XS_Cache__Memcached__Fast_set, file, "$@");
        XSANY.any_i32 = CMD_REPLACE ;
        cv = newXSproto_portable("Cache::Memcached::Fast::add", XS_Cache__Memcached__Fast_set, file, "$@");
        XSANY.any_i32 = CMD_ADD ;
        cv = newXSproto_portable("Cache::Memcached::Fast::prepend", XS_Cache__Memcached__Fast_set, file, "$@");
        XSANY.any_i32 = CMD_PREPEND ;
        cv = newXSproto_portable("Cache::Memcached::Fast::prepend_multi", XS_Cache__Memcached__Fast_set_multi, file, "$@");
        XSANY.any_i32 = CMD_PREPEND ;
        cv = newXSproto_portable("Cache::Memcached::Fast::replace_multi", XS_Cache__Memcached__Fast_set_multi, file, "$@");
        XSANY.any_i32 = CMD_REPLACE ;
        cv = newXSproto_portable("Cache::Memcached::Fast::append_multi", XS_Cache__Memcached__Fast_set_multi, file, "$@");
        XSANY.any_i32 = CMD_APPEND ;
        cv = newXSproto_portable("Cache::Memcached::Fast::cas_multi", XS_Cache__Memcached__Fast_set_multi, file, "$@");
        XSANY.any_i32 = CMD_CAS ;
        cv = newXSproto_portable("Cache::Memcached::Fast::add_multi", XS_Cache__Memcached__Fast_set_multi, file, "$@");
        XSANY.any_i32 = CMD_ADD ;
        cv = newXSproto_portable("Cache::Memcached::Fast::set_multi", XS_Cache__Memcached__Fast_set_multi, file, "$@");
        XSANY.any_i32 = 0 ;
        cv = newXSproto_portable("Cache::Memcached::Fast::gets", XS_Cache__Memcached__Fast_get, file, "$@");
        XSANY.any_i32 = CMD_GETS ;
        cv = newXSproto_portable("Cache::Memcached::Fast::get", XS_Cache__Memcached__Fast_get, file, "$@");
        XSANY.any_i32 = 0 ;
        cv = newXSproto_portable("Cache::Memcached::Fast::gets_multi", XS_Cache__Memcached__Fast_get_multi, file, "$@");
        XSANY.any_i32 = CMD_GETS ;
        cv = newXSproto_portable("Cache::Memcached::Fast::get_multi", XS_Cache__Memcached__Fast_get_multi, file, "$@");
        XSANY.any_i32 = 0 ;
        cv = newXSproto_portable("Cache::Memcached::Fast::incr", XS_Cache__Memcached__Fast_incr, file, "$@");
        XSANY.any_i32 = 0 ;
        cv = newXSproto_portable("Cache::Memcached::Fast::decr", XS_Cache__Memcached__Fast_incr, file, "$@");
        XSANY.any_i32 = CMD_DECR ;
        cv = newXSproto_portable("Cache::Memcached::Fast::incr_multi", XS_Cache__Memcached__Fast_incr_multi, file, "$@");
        XSANY.any_i32 = 0 ;
        cv = newXSproto_portable("Cache::Memcached::Fast::decr_multi", XS_Cache__Memcached__Fast_incr_multi, file, "$@");
        XSANY.any_i32 = CMD_DECR ;
        (void)newXSproto_portable("Cache::Memcached::Fast::delete", XS_Cache__Memcached__Fast_delete, file, "$@");
        (void)newXSproto_portable("Cache::Memcached::Fast::delete_multi", XS_Cache__Memcached__Fast_delete_multi, file, "$@");
        (void)newXSproto_portable("Cache::Memcached::Fast::flush_all", XS_Cache__Memcached__Fast_flush_all, file, "$;$");
        (void)newXSproto_portable("Cache::Memcached::Fast::nowait_push", XS_Cache__Memcached__Fast_nowait_push, file, "$");
        (void)newXSproto_portable("Cache::Memcached::Fast::server_versions", XS_Cache__Memcached__Fast_server_versions, file, "$");
        (void)newXSproto_portable("Cache::Memcached::Fast::namespace", XS_Cache__Memcached__Fast_namespace, file, "$;$");
        (void)newXSproto_portable("Cache::Memcached::Fast::disconnect_all", XS_Cache__Memcached__Fast_disconnect_all, file, "$");
    }
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

